// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('app', ['ionic', 'app.services', 'app.controllers', 'app.routes', 'app.directives'])

.run(function ($ionicPlatform, $rootScope, $ionicPopup, $ionicLoading) {
    $ionicPlatform.ready(function () {
        // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
        // for form inputs)
        if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            cordova.plugins.Keyboard.disableScroll(true);
        }
        if (window.StatusBar) {
            // org.apache.cordova.statusbar required
            StatusBar.styleDefault();
        }
        
    });
    
    $rootScope.Alert = function(titulo, msj) {
        var alertPopup = $ionicPopup.alert({
            title: '<h3>'+ titulo +'</h3>',
            template: msj,
            buttons: [{text: 'Aceptar',type: 'button-positive' }]
        });
        return alertPopup;
    };
    
    $rootScope.erroresAjax = function(error) {
        switch(error){
            case 'tiempo':
                var msj_err = {tit:'Tiempo de espera agotado', 
                               msj:'Es posible que su conexión esté con demoras o no funcione correctamente.<br>Inténtalo nuevamente'};
                break;
            case 'error':
                var msj_err = {tit:'Error de conexión', 
                               msj:'Verifica el estado de la red e inténtalo nuevamente.'};
                break;
            default:
                var msj_err = {tit:'Error Servidor', 
                               msj:error};
        }
        return $rootScope.Alert(msj_err.tit, msj_err.msj);

    }

    $rootScope.loadingIndicator = {
        show: function(texto){ $ionicLoading.show({
                template: '<div class="loader_modal"><ion-spinner icon="spiral" class="spinner-stable"></ion-spinner></div>'+((texto!='') ? '<br>'+texto : ''),
                maxWidth: 200,
                showDelay: 0
            });
        }, 
        hide: function(){
            $ionicLoading.hide();
        }
    };
    
    $rootScope.aleatorios = [];
    
    $rootScope.categoriasList = {
        "1": {text: "Tranquilos", checked: true, valor: 1, ord: 0},
        "2": {text: "Barderos", checked: true, valor: 2, ord: 1},
        "3": {text: "Sexuales", checked: true, valor: 3, ord: 2},
        "4": {text: "Mis yo nunca", checked: true, valor: 4, ord: 3}
    };

    /*paso viejos a la version nueva de MIS YO NUNCA*/
    if(localStorage.getItem("mios")){
        var log = [];
        var mios_s = localStorage.getItem("mios");
        var mios = JSON.parse(mios_s);

        angular.forEach(mios, function(obj, key){
            if(angular.isObject(obj)){
                this.push(obj);
            } else {
                var obj2 = {pregunta: obj, categoria: ''};
                this.push(obj2);
            }
        }, log);

        localStorage.setItem("mios", JSON.stringify(log));
    }
    
})
