angular.module('app.controllers', [])
  
.controller('yoNuncaCtrl', function ($scope, $stateParams) {
    /*if(AdMob){
        // oculto publicidad
        AdMob.hideBanner();
    }*/
    
    $scope.color = 'button-stable';
    if(!localStorage.getItem("btnEnviar")){
        $scope.color = 'button-calm';
        localStorage.setItem("btnEnviar", true);
    }
    /*$scope.cambiar = function(){
        $scope.color = 'button-stable';
    }*/
    
    $scope.compartir = function(){
        window.plugins.socialsharing.share('Descargá Yo Nunca Argentino. ', 'Descargá Yo Nunca Argentino', null, 'https://play.google.com/store/apps/details?id=com.emisferio.yonunca');
    };

})
   
.controller('jugarCtrl', function ($scope, $rootScope, $stateParams, $timeout, Preguntas, CrearBanner) {
    var datos = Preguntas.get($stateParams.categoria);
    $scope.pregunta = datos.pregunta;
    $scope.categoria = datos.categoria;
    
    $scope.clase_jugar='visiblee';
    
    $scope.getPregunta = function(){
        $scope.clase_jugar='hiddenn';
        $timeout(function(){
            // paso la categoria
            datos = Preguntas.get($stateParams.categoria);
            $scope.pregunta = datos.pregunta;
            $scope.categoria = datos.categoria;
            $scope.clase_jugar='visiblee';
        }, 300);
    }
    
    var promise = CrearBanner();
    
    
//    initBanner();
    
    $scope.hablar = function(){
        navigator.globalization.getPreferredLanguage(
            function (language) {
                TTS.speak({
                    text: $scope.pregunta,
                    locale: language.value
                }, function () {
                    // terminado
                }, function (reason) {
                    $rootScope.Alert('Error', reason);
                });
            },
            function () {
                $rootScope.Alert('Error', 'No se detectó el idioma.');
            }
        );
    };
    
    $scope.compartir = function(){
        window.plugins.socialsharing.share('"'+$scope.pregunta+'" Descargá Yo Nunca Argentino. ', 'Descargá Yo Nunca Argentino', null, 'https://play.google.com/store/apps/details?id=com.emisferio.yonunca');
    };

})

.controller('categoriasCtrl', function ($scope, $state, $stateParams, $rootScope, $ionicPopup) {
        
    $scope.validarMios = function(){
        if(localStorage.getItem("mios")){
            $state.go('jugar', { 'categoria':4});
        } else {
            var confirmPopup = $ionicPopup.confirm({
                title: '<h3>Aviso</h3>',
                template: 'Todavía no enviaste ningún yo nunca.<br><b>¿Deseas enviar el primero?</b>',
                buttons: [
                    {text: 'NO'},
                    {text: '<b>SI</b>',
                        type: 'button-positive',
                        onTap: function (e) {
                            return true;
                        }
                    }]
            });

            confirmPopup.then(function (res) {
                if (res) {
                    $state.go('envAnosTusPreguntas');
                } else {
                    // cancelado
                }
            });

        }
    }
    
    $scope.enviarYoNunca = function(){
        $state.go('envAnosTusPreguntas');
    }
        
    $scope.showPopup = function () {
        $scope.desactivado = true;
        if(localStorage.getItem("mios")){
            $scope.desactivado = false;
        }

        var myPopup = $ionicPopup.show({
            template: '<div class="list">'+
                        '<ion-checkbox ng-repeat="item in categoriasList | orderBy:\'ord\'" ng-model="item.checked" ng-checked="item.checked" ng-hide="desactivado && item.valor==4">'+
                            '{{ item.text }}'+
                        '</ion-checkbox>'+
                        '</div>',
            title: 'Aleatorios',
            subTitle: 'Elige las categorías que quieras',
            cssClass: 'modal_aleatorio',
            scope: $scope,
            buttons: [
                    { text: 'Cancelar' },
                    {
                        text: '<b>Jugar</b>',
                        type: 'button-positive',
                        onTap: function (e) {
                            return true;
                        }
                    }]
        });
        myPopup.then(function (res) {
            if(res){
                // borro los aleatorios viejos
                $rootScope.aleatorios = [];
                var seleccionado = 0;

                angular.forEach($rootScope.categoriasList, function(obj, key) {
                    if(obj.checked == true){
                        if(obj.valor == 4){
                            if(!localStorage.getItem("mios")){
                                // si no tengo mios, no guardo el valor
                                return;
                            }
                        }
                        
                        seleccionado++;
                        // guardo las categorias tildadas en array
                        $rootScope.aleatorios.push(obj.valor);
                    }
                });
                
                if(seleccionado > 0){
                    if(!localStorage.getItem("mios")){
//                        $rootScope.Alert('Aviso', 'Todavía no enviaste ningún yo nunca.<br>La categoría <b>Mis yo nunca</b> no se muestra.');
                    }
                    $state.go('jugar', { 'categoria': 'aleatorio'});
                    myPopup.close();
                } else {
                    $rootScope.Alert('Aviso', 'Debes seleccionar al menos <b>una categoría</b> como mínimo.');
                }
                
            }
        });
    };
    
})

.controller('cMoSeJuegaCtrl', ['$scope', '$stateParams', function ($scope, $stateParams) {

}])
   
.controller('envAnosTusPreguntasCtrl', function ($scope, $stateParams, conexionAPI, $rootScope, $ionicPopup, $ionicModal) {
    $scope.formData = {pais:(localStorage.getItem("get_pais") ? localStorage.getItem("get_pais") : '')};
    $scope.mios = [];
    $scope.soyPais = (localStorage.getItem("soyPais") == 'false' ? false : true);
    $scope.hayMios = false;

    $scope.mensaje_expansion = function(){
        localStorage.setItem("mensaje_expansion", true);
        $scope.dataModal = {ok: $scope.soyPais};

        $ionicPopup.prompt({
            title: 'Novedad',
            template: '<p class="padding">¡Vamos a expandir el <b>Yo Nunca</b> entre todos!<br><b>¿Eres Argentino?</b></p>'+
                      '<ion-checkbox ng-model="dataModal.ok" ng-checked="dataModal.ok">Si, soy Argentino</ion-checkbox>',
            cssClass: 'modal_aleatorio',
            scope: $scope,
            buttons: [{
                text: 'Aceptar', 
                type: 'button-positive',
                onTap: function(){
                    return $scope.dataModal.ok || false;
                }
            }]
        }).then(function(res) {
            if(res == null) return; // si presiono boton back
            
            localStorage.setItem("soyPais", res);

            if(res == false && res != $scope.soyPais){
                $rootScope.Alert('¡Genial!', 'El país que reciba la mayor cantidad de yo nunca <b>será el primero en obtener su aplicación oficial.</b>');
            }

            $scope.soyPais = res;
        });
    };

    if(!localStorage.getItem("mensaje_expansion")){
        $scope.mensaje_expansion();
    }
    

     /*MIS YO NUNCA*/    
    if(localStorage.getItem("mios")){
        $scope.hayMios = true;
        var mios = localStorage.getItem("mios");
        $scope.mios = JSON.parse(mios);
    }
    
    $scope.submit = function(){
        var opc = 'enviar';
        
        if($scope.soyPais){
            $scope.formData.pais = 'Argentina';
        } else {
            localStorage.setItem("get_pais", $scope.formData.pais);
        }


        if(!$scope.formData.pais || $scope.formData.pais == ''){
            $rootScope.Alert('Aviso', 'Debes <b>seleccionar un país</b>');
            return;
        }
        if(!$scope.formData.categoria || $scope.formData.categoria == ''){
            $rootScope.Alert('Aviso', 'Debes <b>seleccionar una categoría</b>');
            return;
        }
        
        if(!$scope.formData.pregunta || $scope.formData.pregunta.length < 6){
            $rootScope.Alert('Aviso', 'La frase debe contener al menos <b>6 caracteres</b>.');
            return;
        }
        
        $scope.agregarMio($scope.formData);

        
        //return; // borrar!!
        

        var promise = conexionAPI(opc, $scope.formData);
        $rootScope.loadingIndicator.show('Enviando...');

        $scope.formData.pregunta='';
        
        promise.then(
            function(data) { // TODO OK
                
                $rootScope.loadingIndicator.hide();
                $rootScope.Alert('Muchas Gracias', '¡Tu yo nunca fue <b>enviado correctamente</b>!');
                
//                $scope.formData.categoria='';
                
            },
            function(error) { // ERRORES
                $rootScope.loadingIndicator.hide();
                $rootScope.Alert('Aviso', 'Ocurrió un error al enviar tu yo nunca, de todas maneras, <br><b>ya te lo guardamos!</b> :)');
//                var modal_err = $rootScope.erroresAjax(error);
            }
        );
    };
    
    $scope.agregarMio = function(formData){
        var texto = formData.pregunta;
        texto = texto.toLowerCase();
        texto = texto.replace('yo nunca','');
        texto = texto.trim();
        var obj = {pregunta: texto, categoria: formData.categoria};
        // el "Yo nunca" lo pongo cuando lo muestro
        $scope.mios.push(obj);
        $scope.actualizarMio();
    }
    $scope.borrarMio = function(idx){
        $scope.mios.splice(idx, 1);
        $scope.actualizarMio();
    }
    $scope.actualizarMio = function(){
        if($scope.mios.length >= 1){
            $scope.hayMios = true;
            localStorage.setItem("mios", JSON.stringify($scope.mios));
        } else {
            $scope.hayMios = false;
            localStorage.removeItem('mios');
        }
    }

    $scope.shouldShowDelete = false;
    $scope.borrarActivo = '';
    /*MODAL MIOS*/
    $ionicModal.fromTemplateUrl('templates/mis-yonunca.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.modal = modal;
    });
    $scope.openModal = function () {
        $scope.shouldShowDelete = false;
        $scope.borrarActivo = '';
        $scope.modal.show();
    };
    $scope.closeModal = function () {
        $scope.modal.hide();
    };
    $scope.toggleBorrar = function () {
        $scope.shouldShowDelete = !$scope.shouldShowDelete;
        $scope.borrarActivo = ($scope.shouldShowDelete?'button-assertive':'');

    };

    $scope.compartir = function(texto){
        window.plugins.socialsharing.share('"Yo nunca '+texto+'" Descargá Yo Nunca Argentino. ', 'Descargá Yo Nunca Argentino', null, 'https://play.google.com/store/apps/details?id=com.emisferio.yonunca');
    };

    
})
   
.controller('acercaCtrl', ['$scope', '$stateParams', function ($scope, $stateParams) {


}])

 